﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using Telerik.Windows.Controls.UI;
using Telerik.Windows.Controls.Core.Data;

namespace UnboundButtonAndComboBox
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		private static CustomCommand customCommand;

		public static CustomCommand CustomCommand
		{
			get
			{
				return customCommand;
			}
			private set
			{
				customCommand = value;
			}
		}

		static Window1()
		{
			customCommand = new CustomCommand();
		}

		public Window1()
		{
			InitializeComponent();

			CreateDataSourceAndBind();

			// bind the custom command to the CustomCommandExecuted handler
			this.CommandBindings.Add(new CommandBinding(customCommand, new ExecutedRoutedEventHandler(CustomCommandExecuted)));
		}

		private void CreateDataSourceAndBind()
		{
			List<String> dataSource = new List<String>();

			for (int i = 0; i < 20; i++)
			{
				dataSource.Add(i.ToString());
			}

			this.sampleRadGridView.ItemsSource = dataSource;
		}

		public void CustomCommandExecuted(object sender, ExecutedRoutedEventArgs e)
		{
			Button button = e.OriginalSource as Button;
			DataRecord record = button.DataContext as DataRecord;
			// get ComboBox by using the command parameter
			ComboBox combo = e.Parameter as ComboBox;
			
			// execute command logic
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			Button button = e.OriginalSource as Button;
			DataRecord record = button.DataContext as DataRecord;
			// get ComboBox by traversing the visual tree
			ComboBox combo = FindElement("combo", 2, button) as ComboBox;

			// execute command logic
		}

		private static object FindElement(string elementName, int columnIndex, DependencyObject searchStartPoint)
		{
			if (searchStartPoint != null)
			{
				Grid grid = FindGridViewCellsHost(searchStartPoint);
				GridViewCell cell = FindGridViewCell(grid, columnIndex);

				if (cell != null)
					return cell.Template.FindName(elementName, cell);
			}

			return null;
		}

		private static Grid FindGridViewCellsHost(DependencyObject searchStartPoint)
		{
			DependencyObject parent = VisualTreeHelper.GetParent(searchStartPoint);

			while ((parent != null) && !(parent is Grid))
				parent = VisualTreeHelper.GetParent(parent);

			return parent as Grid;
		}

		private static GridViewCell FindGridViewCell(Grid cellsHost, int columnIndex)
		{
			GridViewCell cell = null;

			if (cellsHost != null)
			{
				cell = cellsHost.Children[columnIndex] as GridViewCell;
			}

			return cell;
		}
	}

	public class CustomCommand : RoutedCommand
	{
	}
}
